//free source of TextToSC program
//Initial idea (and initial realization) of M. E. Shmelev
//reference to me in your documentation is recommended
//(I'll be happy)
//YOU MAY (not must) ALSO E-MAIL ME if you're modifying
//this code or use it anywhere;
//E-mail:   super-m@ya.ru
//Site:     http://super-m.savesoul.ru/

#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <string.h>
#define V_INFO "0.8.3"
#define NTEXT 19
#define NN 76
#define NStrings 256
#define NAnalizeStrings 8

//text and [interface] languages
enum lang{
     RUSSIAN,
     ENGLISH
};//langs
int Language=ENGLISH;
char *text[NTEXT]; //text strings

//for converting
enum formats{
     //cyrillic
     STARCRAFT,
     DOS866,
     WIN1251,
     KOI8,
     DOS855,
     MAC,
     ISO,
     KOI7,
     TRANSLIT,
     ISOIR111,
     KOI8U,
     MACU,
     //turkish
     WIN1254,
     DOS857,
     MACTURK,
     ISO8859_9,
     //west-eur
     DOS850,
     WIN1252,
     ISO8859_1,
     ISO8859_15,
     MACROMAN
};//formats
enum lf_styles{
     LFS_LF,   //<LF>
     LFS_CRLF, //<CR><LF>,
     LFS_DEFAULT, //default for encoding
     LFS_NOALT //dont alter
};//line feed style
char *cmdkey[NN]; //possible switches
int informat=DOS866, outformat=STARCRAFT;
int LfStyle=LFS_DEFAULT;
//rus sets
char koi8[256], d855[256], koi7[256], mac[256], iso[256];
//Ext sets:
 #include "cyr.h"
 //turk
 #include "turk.h"
 //west-eur
 #include "west.h"
bool SameFiles=false;
bool AllowBefore32=true, AllowExtendedCyrillic=true, AllowStrings=true;
bool AllowAnalizeText=true, SourceStyle=false, HtmlStyle=false;
bool NoQuoteTranslit=false, DenieSgmlSubst=false, PreserveDateTime=false;

//symbols
unsigned char big_tire=22, paragraph=21, abzac=20, center_point=7;
unsigned char quote=39, doublequote=34;

bool NowString = false;
char *theString="", outString[32];
//int strnum;
char *strings[NStrings];

//needed for text analysis
unsigned char prevchar=32;

//date-time
struct ftime fDateTime;

void initkeys(void);
void initlang(void);
unsigned char TransCode(unsigned char ch);
void inittables(void);
unsigned char OutCode(unsigned char ch, unsigned char *table);
int searchkey(char *stroka);
void help(void);
unsigned char GetExtCode(int extc, int *table);
void TcodeString(char *astr);

void initkeys(void) //᫥ 祩  ப
{
 int i;
 for (i=0; i<NStrings; i++) strings[i]="";
 //switches
 cmdkey[0]="/?";
 cmdkey[1]="-?";
 cmdkey[2]="-w";
 cmdkey[3]="-ni";
 cmdkey[4]="-todos";
 cmdkey[5]="-u"; //for compat-ty with v 0.5 and earlier
 cmdkey[6]="-koi8"; //same as -u , means koi8-r
 cmdkey[7]="-nec";
 cmdkey[8]="-32";
 cmdkey[9]="-nstr";
 cmdkey[10]="-src";
 cmdkey[11]="-en";
 cmdkey[12]="-855";
 cmdkey[13]="-mac";
 cmdkey[14]="-iso";
 cmdkey[15]="-win"; //-w
 cmdkey[16]="-koi8r"; //-koi8
 cmdkey[17]="-tow";
 cmdkey[18]="-to866"; //-todos
 cmdkey[19]="-towin"; //-tow
 cmdkey[20]="-tokoi8";
 cmdkey[21]="-tokoi8r"; //-tokoi8
 cmdkey[22]="-tou"; //-tokoi8
 cmdkey[23]="-to855";
 cmdkey[24]="-tomac";
 cmdkey[25]="-toiso";
 cmdkey[26]="-sc"; //from SC
 cmdkey[27]="-dos"; //from dos
 cmdkey[28]="-866"; //-dos
 cmdkey[29]="-tosc"; //to SC
 cmdkey[30]="-nta"; //disable text analizer
 cmdkey[31]="-tokoi7"; //to koi7
 cmdkey[32]="-koi7"; //from koi7
 cmdkey[33]="-iso8859_5"; //-iso
 cmdkey[34]="-toiso8859_5"; //-toiso
 cmdkey[35]="-translit";
 cmdkey[36]="-totl"; //-translit
 cmdkey[37]="-nqt"; //no translit to quote `
 cmdkey[38]="-rus"; //russian interface
 cmdkey[39]="-koi8u";
 cmdkey[40]="-tokoi8u";
 cmdkey[41]="-macu";
 cmdkey[42]="-mac_u"; //-macu
 cmdkey[43]="-tomacu";
 cmdkey[44]="-tomac_u"; //-tomacu
 cmdkey[45]="-iso_ir_111";
 cmdkey[46]="-isoir111"; //-iso_ir_111
 cmdkey[47]="-toiso_ir_111";
 cmdkey[48]="-toisoir111"; //-toiso_ir_111
 cmdkey[49]="-1251"; //w
 cmdkey[50]="-to1251"; //tow
 cmdkey[51]="-857";
 cmdkey[52]="-to857";
 cmdkey[53]="-1254";
 cmdkey[54]="-to1254";
 cmdkey[55]="-iso8859_9";
 cmdkey[56]="-toiso8859_9";
 cmdkey[57]="-macturk";
 cmdkey[58]="-tomacturk";
 cmdkey[59]="-lf";
 cmdkey[60]="-crlf";
 cmdkey[61]="-noenc";
 cmdkey[62]="-850";
 cmdkey[63]="-1252";
 cmdkey[64]="-iso8859_1";
 cmdkey[65]="-iso8859_15";
 cmdkey[66]="-macroman";
 cmdkey[67]="-to850";
 cmdkey[68]="-to1252";
 cmdkey[69]="-toiso8859_1";
 cmdkey[70]="-toiso8859_15";
 cmdkey[71]="-tomacroman";
 cmdkey[72]="-noaltlf";
 cmdkey[73]="-html";
 cmdkey[74]="-dhcs";
 cmdkey[75]="-pdt";
 //strings
 strings[0]="+-";
 strings[1]="O/oo";
 strings[2]="(R)";
 strings[3]="(c)";
 strings[4]="(TM)";
 strings[5]="...";
 strings[6]="";
 strings[7]="";
 strings[8]="Th";
 strings[9]="";
 strings[10]="";
 strings[11]="mu";
 strings[12]="<<";
 strings[13]=">>";
 strings[14]="No.";
 //translit
 strings[160]="a"; strings[161]="b"; strings[162]="v";
 strings[163]="g"; strings[164]="d"; strings[165]="e";
 strings[166]="j"; strings[167]="z"; strings[168]="i";
 strings[169]="y"; strings[170]="k"; strings[171]="l";
 strings[172]="m"; strings[173]="n"; strings[174]="o";
 strings[175]="p"; strings[224]="r"; strings[225]="s";
 strings[226]="t"; strings[227]="u"; strings[228]="f";
 strings[229]="h"; strings[230]="c"; strings[231]="ch";
 strings[232]="sh"; strings[233]="sch"; strings[234]="`";
 strings[235]="y"; strings[236]="`"; strings[237]="e";
 strings[238]="yu"; strings[239]="ya";
 strings[240]="Yo"; strings[241]="yo";
 strings[242]="E"; strings[243]="e";
 strings[244]="I"; strings[245]="i";
 strings[246]="Y"; strings[247]="y";
 strings[128]="A"; strings[129]="B"; strings[130]="V";
 strings[131]="G"; strings[132]="D"; strings[133]="E";
 strings[134]="J"; strings[135]="Z"; strings[136]="I";
 strings[137]="Y"; strings[138]="K"; strings[139]="L";
 strings[140]="M"; strings[141]="N"; strings[142]="O";
 strings[143]="P"; strings[144]="R"; strings[145]="S";
 strings[146]="T"; strings[147]="U"; strings[148]="F";
 strings[149]="H"; strings[150]="C"; strings[151]="Ch";
 strings[152]="Sh"; strings[153]="Sch"; strings[154]="`";
 strings[155]="Y"; strings[156]="`"; strings[157]="E";
 strings[158]="Yu"; strings[159]="Ya";
 return;
}//end initkeys

void initlang(void)
{
 switch(Language)
 {
   case RUSSIAN:
    //info
    text[0]="८ࠧ ⥪⮢  ࠧ ஢ "
     "( ன ॢ ப)\n"
     " TextToSC  "V_INFO";  ᡮન "__DATE__
     "\nFor ENGLISH help type: texttosc -? -en";
    //help
    text[1]="   ন 모:";
    text[2]="     筮-ய᪨ (ਫ);";
    text[3]="     檨; -ய᪨;";
    text[4]="⠪ 맮 ணࠬ: texttosc [] [䠩1 䠩2]";
    text[5]="  ( ᯨ᮪ .  䠩 README):";
    text[6]="       -32      ࠡ뢠 㦥 ᨬ;";
    text[7]="       -ni      뢮 ᢥ  ᨨ;";
    text[8]="       -en     USE ENGLISH LANGUAGE;";
    text[9]="       -?  /?  ;";
    text[10]="䠩1   室 䠩;";
    text[11]="䠩2   䠩, 㤠  १.";
    text[12]="B頥  襭:";
    text[13]="0 -䠩 ८ࠧ; 1 -䠩  ८ࠧ.";
    text[14]=" ணࠬ . . , , 2001-2003, 2014 .";
    text[15]="http:\/\/super-m.savesoul.ru\/";
    text[16]="E-mail: super-m@ya.ru";
    text[17]="...";
    text[18]=" ⮢.";
   break;
   case ENGLISH:
    //info
    text[0]="Converter of texts in different encodings "
     "(with lf style adjustment)\n"
     " TextToSC version "V_INFO"; Build date "__DATE__
     "\nFor RUSSIAN help type: texttosc -? -rus";
    //help
    text[1]="   Languages supported:";
    text[2]="     east-european (Cyrillic, e.g. Russian);";
    text[3]="     Turkish; west-european;";
    text[4]="Program call syntax: texttosc [swithces] [file1 file2]";
    text[5]="Some swithces (FULL LIST SEE IN readme FILE):";
    text[6]="       -32     do not work with special symbols (<32);";
    text[7]="       -ni     dont show version info;";
    text[8]="       -rus    use Russian interface;";
    text[9]="       -? or /?  help;";
    text[10]="file1  name of input file;";
    text[11]="file2  name of output file.";
    text[12]="Returns exit codes:";
    text[13]="0 -file\'s been converted; 1 -file\'s not been converted.";
    text[14]="Author M. E. Shmelev, Russia, 2001-2003, 2014.";
    text[15]="http:\/\/super-m.savesoul.ru\/";
    text[16]="E-mail: super-m@ya.ru";
    text[17]="Wait...";
    text[18]=" Done.";
   break;
 }//end switch
}//end initlang

unsigned char TransCode(unsigned char ch)
{
 unsigned char ch1, ch2;
 int extch=0; //ext char
 // Ext char positions see in .doc file
 ch1=ch;
 NowString = false;
 switch(informat)
 {
   case KOI8: ch=koi8[ch]; extch=Koi8[ch1]; break;
   case ISOIR111: ch=koi8[ch]; extch=IsoIr111[ch1]; break;
   case KOI8U: ch=koi8[ch]; extch=Koi8U[ch1]; break;
   case DOS855: ch=d855[ch]; extch=D855[ch1]; break;
   case KOI7: ch=koi7[ch]; break;
   case MAC: ch=mac[ch]; extch=Mac[ch1]; break;
   case MACU: ch=mac[ch]; extch=MacU[ch1]; break;
   case ISO: ch=iso[ch]; extch=Iso[ch1]; break;
   case WIN1251: extch=Win1251[ch1]; break;
   case DOS866: extch=D866[ch1]; break;
   case DOS857: extch=D857[ch1]; break;
   case WIN1254: extch=Win1254[ch1]; break;
   case ISO8859_9: extch=Iso8859_9[ch1]; break;
   case MACTURK: extch=MacTurk[ch1]; break;
   case DOS850: extch=D850[ch1]; break;
   case WIN1252: extch=Win1252[ch1]; break;
   case ISO8859_1: extch=Iso8859_1[ch1]; break;
   case ISO8859_15: extch=Iso8859_15[ch1]; break;
   case MACROMAN: extch=MacRoman[ch1]; break;
 }//end switch
 if (informat==STARCRAFT)
 {
  if (ch==176) ch=134;
  if (ch==177) ch=166;
 }//end if (informat==STARCRAFT)
 if (informat==WIN1251)
 {
  //TRANSCODING RUSSIAN SYMBOLS
  if (ch>=240) ch-=16;
  else
  {
   if ((ch>=192)&&(ch<=239)) ch-=64;
   else
   {
    if (ch==168) ch=240; //
    if (ch==184) ch=241; //
   }//end
  }//end else
 }//end if (informat==WIN1251)
 //ext symbols "emulation" (if they not presnt in dest enc)
  #include "emulmain.h"
  #include "emulgraf.h"
  #include "emulcyr.h"
 //SGML substitution for HTML
  #include "sgml.h"
 //text analizing
 if (AllowAnalizeText)
 {
     //for future use
 }//end if
 if ((informat==DOS866) && AllowBefore32)
 {
   if (ch1==paragraph) extch=539;
   if (ch1==abzac) extch=554;
   if (ch1==center_point) extch=555;
   if (ch1==big_tire) extch=523;
   if ((ch1==1)||(ch1==2))
    { ch=79; NowString=true; theString=":-)"; }
   if (ch1==19)
    { ch=33; NowString=true; theString="!!"; }
   if ((ch1==22)||(ch1==28)) ch=95;
 }
 if (! AllowBefore32)
 {
   if (ch==paragraph) ch=38;
   if (ch==abzac) ch=36;
   if (ch==center_point) ch=46;
   if (ch==big_tire) ch=45;
 }
 ch1 = ch;
 if (outformat==WIN1251)
 {
   if (((ch1>=160) && (ch1<=175)) || ((ch1>=128)&&(ch1<=159)))
     ch += 64;
   else
   {
     if ((ch1>=224)&&(ch1<=239)) ch += 16;
     else
     {
       if (ch1==240) ch=168; //
       if (ch1==241) ch=184; //
       if (AllowBefore32)
       {
         //before 32
         if (ch1==7) ch=149; //bold center point
         if (ch1==22) ch=173; //big tire
         if (ch1==21) ch=167; //paragraph
         if (ch1==20) ch=182; //abzac
       }//end AllowBefore32
       //now pseudographic symbols
       if ((ch1>=176) && (ch1<=176)) ch=152; //
     }//end else
   }//end else
 }//end if
 //now quotes
 if (AllowAnalizeText && (! SourceStyle) && (extch==0))
 {
    if (ch1==34) //"
    {
       if ((prevchar==32) || (prevchar<14))
          extch=543;
       else
          extch=559;
    } //end if
    if (ch1==39) //'
    {
       if ((prevchar==32) || (prevchar<14))
          extch=517;
        else
          extch=518;
    } //end if
 }//end if
  #include "old.h"
 ch2=0;
 switch(outformat)
 {
   case KOI8: ch=OutCode(ch,koi8); ch2=GetExtCode(extch,Koi8); break;
   case KOI8U: ch=OutCode(ch,koi8); ch2=GetExtCode(extch,Koi8U); break;
   case ISOIR111: ch=OutCode(ch,koi8); ch2=GetExtCode(extch,IsoIr111); break;
   case DOS855: ch=OutCode(ch,d855); ch2=GetExtCode(extch,D855); break;
   case KOI7: ch=OutCode(ch,koi7); break;
   case MAC: ch=OutCode(ch,mac); ch2=GetExtCode(extch,Mac); break;
   case MACU: ch=OutCode(ch,mac); ch2=GetExtCode(extch,MacU); break;
   case ISO: ch=OutCode(ch,iso); ch2=GetExtCode(extch,Iso); break;
   case WIN1251:  ch2=GetExtCode(extch,Win1251); break;
   case DOS866:  ch2=GetExtCode(extch,D866); break;
   case DOS857:  ch2=GetExtCode(extch,D857); break;
   case WIN1254:  ch2=GetExtCode(extch,Win1254); break;
   case ISO8859_9:  ch2=GetExtCode(extch,Iso8859_9); break;
   case MACTURK:  ch2=GetExtCode(extch,MacTurk); break;
   case DOS850:  ch2=GetExtCode(extch,D850); break;
   case WIN1252:  ch2=GetExtCode(extch,Win1252); break;
   case ISO8859_1:  ch2=GetExtCode(extch,Iso8859_1); break;
   case ISO8859_15:  ch2=GetExtCode(extch,Iso8859_15); break;
   case MACROMAN:  ch2=GetExtCode(extch,MacRoman); break;
 }//end switch
 if (ch2!=0) { ch=ch2; NowString=false; }
 if (outformat==STARCRAFT)
 {
  if (ch==240) ch=133;
  if (ch==241) ch=165;
  if (ch==134) ch=176;
  if (ch==166) ch=177;
 }//end if (outformat==STARCRAFT)
 if (outformat==TRANSLIT)
 {
   if ( ((ch>=128) && (ch<=175)) ||
     ((ch>=224) && (ch<=247)) )
   {
     NowString=true; theString=strings[ch];
     if (NoQuoteTranslit)
     {
       if ((ch==154) || (ch==156))
       { NowString=false; ch='Q'; }
       if ((ch==234) || (ch==236))
       { NowString=false; ch='q'; }
     }
   }
 }
 prevchar = ch1;
 strcpy(outString, theString);
 TcodeString(outString);
 return ch;
}//end TransCode

void inittables(void)
{
 int i;
 for (i=0; i<256; i++)
 {
   //main chars
   d855[i]=koi7[i]=0;
   koi8[i]=mac[i]=iso[i]=0;
 }//end for
 koi8[193]=''; iso[0xd0]=''; d855[0xa0]=''; mac[0xe0]='';
 koi8[194]=''; iso[0xd1]=''; d855[0xa2]=''; mac[0xe1]='';
 koi8[215]=''; iso[0xd2]=''; d855[0xeb]=''; mac[0xe2]='';
 koi8[199]=''; iso[0xd3]=''; d855[0xac]=''; mac[0xe3]='';
 koi8[196]=''; iso[0xd4]=''; d855[0xa6]=''; mac[0xe4]='';
 koi8[197]=''; iso[0xd5]=''; d855[0xa8]=''; mac[0xe5]='';
 koi8[163]=''; iso[0xf1]=''; d855[0x84]=''; mac[0xde]=''; //ࠢ  8
 koi8[214]=''; iso[0xd6]=''; d855[0xe9]=''; mac[0xe6]='';
 koi8[218]=''; iso[0xd7]=''; d855[0xf3]=''; mac[0xe7]='';
 koi8[201]=''; iso[0xd8]=''; d855[0xb7]=''; mac[0xe8]='';
 koi8[202]=''; iso[0xd9]=''; d855[0xbd]=''; mac[0xe9]='';
 koi8[203]=''; iso[0xda]=''; d855[0xc6]=''; mac[0xea]='';
 koi8[204]=''; iso[0xdb]=''; d855[0xd0]=''; mac[0xeb]='';
 koi8[205]=''; iso[0xdc]=''; d855[0xd2]=''; mac[0xec]='';
 koi8[206]=''; iso[0xdd]=''; d855[0xd4]=''; mac[0xed]='';
 koi8[207]=''; iso[0xde]=''; d855[0xd6]=''; mac[0xee]='';
 koi8[208]=''; iso[0xdf]=''; d855[0xd8]=''; mac[0xef]='';
 koi8[210]=''; iso[0xe0]=''; d855[0xe1]=''; mac[0xf0]='';
 koi8[211]=''; iso[0xe1]=''; d855[0xe3]=''; mac[0xf1]='';
 koi8[212]=''; iso[0xe2]=''; d855[0xe5]=''; mac[0xf2]='';
 koi8[213]=''; iso[0xe3]=''; d855[0xe7]=''; mac[0xf3]='';
 koi8[198]=''; iso[0xe4]=''; d855[0xaa]=''; mac[0xf4]='';
 koi8[200]=''; iso[0xe5]=''; d855[0xb5]=''; mac[0xf5]='';
 koi8[195]=''; iso[0xe6]=''; d855[0xa4]=''; mac[0xf6]='';
 koi8[222]=''; iso[0xe7]=''; d855[0xfb]=''; mac[0xf7]='';
 koi8[219]=''; iso[0xe8]=''; d855[0xf5]=''; mac[0xf8]='';
 koi8[221]=''; iso[0xe9]=''; d855[0xf9]=''; mac[0xf9]='';
 koi8[223]=''; iso[0xea]=''; d855[0x9e]=''; mac[0xfa]='';
 koi8[217]=''; iso[0xeb]=''; d855[0xf1]=''; mac[0xfb]='';
 koi8[216]=''; iso[0xec]=''; d855[0xed]=''; mac[0xfc]='';
 koi8[220]=''; iso[0xed]=''; d855[0xf7]=''; mac[0xfd]='';
 koi8[192]=''; iso[0xee]=''; d855[0x9c]=''; mac[0xfe]='';
 koi8[209]=''; iso[0xef]=''; d855[0xde]=''; mac[0xdf]='';
 koi8[225]=''; iso[0xb0]=''; d855[0xa1]=''; mac[0x80]='';
 koi8[226]=''; iso[0xb1]=''; d855[0xa3]=''; mac[0x81]='';
 koi8[247]=''; iso[0xb2]=''; d855[0xec]=''; mac[0x82]='';
 koi8[231]=''; iso[0xb3]=''; d855[0xad]=''; mac[0x83]='';
 koi8[228]=''; iso[0xb4]=''; d855[0xa7]=''; mac[0x84]='';
 koi8[229]=''; iso[0xb5]=''; d855[0xa9]=''; mac[0x85]='';
 koi8[179]=''; iso[0xa1]=''; d855[0x85]=''; mac[0xdd]='';
 koi8[246]=''; iso[0xb6]=''; d855[0xea]=''; mac[0x86]='';
 koi8[250]=''; iso[0xb7]=''; d855[0xf4]=''; mac[0x87]='';
 koi8[233]=''; iso[0xb8]=''; d855[0xb8]=''; mac[0x88]='';
 koi8[234]=''; iso[0xb9]=''; d855[0xbe]=''; mac[0x89]='';
 koi8[235]=''; iso[0xba]=''; d855[0xc7]=''; mac[0x8a]='';
 koi8[236]=''; iso[0xbb]=''; d855[0xd1]=''; mac[0x8b]='';
 koi8[237]=''; iso[0xbc]=''; d855[0xd3]=''; mac[0x8c]='';
 koi8[238]=''; iso[0xbd]=''; d855[0xd5]=''; mac[0x8d]='';
 koi8[239]=''; iso[0xbe]=''; d855[0xd7]=''; mac[0x8e]='';
 koi8[240]=''; iso[0xbf]=''; d855[0xdd]=''; mac[0x8f]='';
 koi8[242]=''; iso[0xc0]=''; d855[0xe2]=''; mac[0x90]='';
 koi8[243]=''; iso[0xc1]=''; d855[0xe4]=''; mac[0x91]='';
 koi8[244]=''; iso[0xc2]=''; d855[0xe6]=''; mac[0x92]='';
 koi8[245]=''; iso[0xc3]=''; d855[0xe8]=''; mac[0x93]='';
 koi8[230]=''; iso[0xc4]=''; d855[0xab]=''; mac[0x94]='';
 koi8[232]=''; iso[0xc5]=''; d855[0xb6]=''; mac[0x95]='';
 koi8[227]=''; iso[0xc6]=''; d855[0xa5]=''; mac[0x96]='';
 koi8[254]=''; iso[0xc7]=''; d855[0xfc]=''; mac[0x97]='';
 koi8[251]=''; iso[0xc8]=''; d855[0xf6]=''; mac[0x98]='';
 koi8[253]=''; iso[0xc9]=''; d855[0xfa]=''; mac[0x99]='';
 koi8[255]=''; iso[0xca]=''; d855[0x9f]=''; mac[0x9a]='';
 koi8[249]=''; iso[0xcb]=''; d855[0xf2]=''; mac[0x9b]='';
 koi8[248]=''; iso[0xcc]=''; d855[0xee]=''; mac[0x9c]='';
 koi8[252]=''; iso[0xcd]=''; d855[0xf8]=''; mac[0x9d]='';
 koi8[224]=''; iso[0xce]=''; d855[0x9d]=''; mac[0x9e]='';
 koi8[241]=''; iso[0xcf]=''; d855[0xe0]=''; mac[0x9f]='';
 // no  in koi7
 for (i=192; i<255; i++)
     koi7[i]=koi8[i];
 for (i=160; i<192; i++)
     koi7[i]=(unsigned char)(i-128);
 koi7[36]=253; //
}//end inittables

unsigned char OutCode(unsigned char ch, unsigned char *table)
{
  int i=-1;
  do
  {
    i++;
    //printf("[%d]=%c", i, table[i]);
  } while ((i<256) && (ch!=table[i]));
  if (i>=256) return ch;
  else return (unsigned char)i;
}//end OutCode

int searchkey(char *stroka)
{
 char *s;
 bool fnd=false;
 int i=-1;
 while (!fnd && (i<NN)) //ࠡ⪠ 祩
 {
  i++;
  s=cmdkey[i];
  fnd=(strcmp(s,stroka)==0);
 }//end while
 if (!fnd) i=-1;
 return i;
}//end searchkey

void help(void) //뢮 
{
 puts(text[0]); //text[0]
 puts(text[1]);
 puts(text[2]);
 puts(text[3]);
 puts(text[4]);
 puts(text[5]);
 puts(text[6]);
 puts(text[7]);
 puts(text[8]);
 puts(text[9]);
 puts(text[10]);
 puts(text[11]);
 puts(text[12]);
 puts(text[13]);
 puts(text[14]);
 puts(text[15]);
 puts(text[16]);
 return;
}//end help

unsigned char GetExtCode(int extc, int *table)
{
  int i;
  unsigned char ret=0;
  if (extc==0)
    return 0;
  for (i=1; (i<256) && (ret==0); i++)
  {
    if (table[i]==extc)
       ret=(unsigned char)i;
  }
  return ret;
}//end GetExtCode

void TcodeString(char *astr)
{
  unsigned char ch, rch, *tbl;
  int i, len;
  switch (outformat)
  {
  case ISOIR111:
  case KOI8U:
  case KOI7:
  case KOI8: tbl=koi8; break;
  case ISO: tbl=iso; break;
  case MACU:
  case MAC: tbl=mac; break;
  case DOS855: tbl=d855; break;
  default: tbl=NULL;
  }
  if (tbl==NULL) return;
  len=strlen(astr);
  for (i=0; i<len; i++)
  {
    ch=astr[i];
    rch=OutCode(ch, tbl);
    astr[i]=rch;
  }
}//end TcodeString


int main(int argc, char *argv[])
{
 int ret, i;
 int NumFiles=0;
 bool showVInfo=true, showHelp=false;
 bool loop=true, filesOk, PrintCurChar;
 bool OnlyAdjLF=false;
 unsigned char ch1, ch2;
 int num1, num2, DefaultLFStyle=LFS_NOALT;
 FILE *in1, *out2;
 char *path1, *path2, destfile[256];
 char buffer[500];
 if (argc==1)
 {
  initlang(); help(); return 1;
 }//end if
 initkeys();
 inittables();
 for (i=1;i<argc;i++)
 {
  ret=searchkey(argv[i]);
  switch (ret)
  {
   case 0: /* -? */
   case 1: /* /? */showHelp=true; break;
   case 3: /* -ni */showVInfo=false; break;
   case 7: /* -nec */AllowExtendedCyrillic=false; break;
   case 8: /* -32 */AllowBefore32=false; break;
   case 9: /* -nstr */AllowStrings=false; break;
   case 10: /* -src */SourceStyle=true; break;
   case 30: /* -nta */AllowAnalizeText=false; break;
   case 11: /* -en */Language=ENGLISH; break;
   case 37: /* -nqt */NoQuoteTranslit=true; break;
   case 38: /* -rus */Language=RUSSIAN; break;
   case 59: /* -lf */LfStyle=LFS_LF; break;
   case 60: /* -crlf */LfStyle=LFS_CRLF; break;
   case 61: /* -noenc */OnlyAdjLF=true; break;
   case 72: /* -noaltlf */LfStyle=LFS_NOALT; break;
   case 73: /* -html */HtmlStyle=SourceStyle=true; AllowAnalizeText=false; break;
   case 74: /* -dhcs */DenieSgmlSubst=true; break;
   case 75: /* -pdt */PreserveDateTime=true; break;
   //in formats
   case 28: /* -866 */
   case 27: /* -dos */informat=DOS866; break;
   case 49: /* -1251 */
   case 15: /* -win */
   case 2: /* -w */informat=WIN1251; break;
   case 5: /* -u */
   case 16: /* -koi8r */
   case 6: /* -koi8 */informat=KOI8; break;
   case 12: /* -855 */informat=DOS855; break;
   case 32: /* -koi7 */informat=KOI7; break;
   case 13: /* -mac */informat=MAC; break;
   case 33:
   case 14: /* -iso */informat=ISO; break;
   case 26: /* -sc */informat=STARCRAFT; break;
   case 39: /* -koi8u */informat=KOI8U; break;
   case 41: /* -macu */
   case 42: /* -mac_u */informat=MACU; break;
   case 45: /* -iso_ir_111 */
   case 46: /* -isoir111 */informat=ISOIR111; break;
   case 51: /* -857 */informat=DOS857; break;
   case 53: /* -1254 */informat=WIN1254; break;
   case 55: /* -iso8859_9 */informat=ISO8859_9; break;
   case 57: /* -macturk */informat=MACTURK; break;
   case 62: /* -850 */informat=DOS850; break;
   case 63: /* -1252 */informat=WIN1252; break;
   case 64: /* -iso8859_1 */informat=ISO8859_1; break;
   case 65: /* -iso8859_15 */informat=ISO8859_15; break;
   case 66: /* -macroman */informat=MACROMAN; break;
   //out formats
   case 50: /* -to1251 */
   case 19: /* -towin */
   case 17: /* -tow */outformat=WIN1251; DefaultLFStyle=LFS_CRLF; break;
   case 18: /* -to866 */
   case 4: /* -todos */outformat=DOS866; DefaultLFStyle=LFS_CRLF; break;
   case 22: /* -tou */
   case 21: /* -tokoi8r */
   case 20: /* -tokoi8 */outformat=KOI8; DefaultLFStyle=LFS_LF; break;
   case 23: /* -to855 */outformat=DOS855; DefaultLFStyle=LFS_CRLF; break;
   case 31: /* -tokoi7 */outformat=KOI7; DefaultLFStyle=LFS_CRLF; break;
   case 24: /* -tomac */outformat=MAC; DefaultLFStyle=LFS_LF; break;
   case 34:
   case 25: /* -toiso */outformat=ISO; DefaultLFStyle=LFS_LF; break;
   case 29: /* -tosc */outformat=STARCRAFT; DefaultLFStyle=LFS_CRLF; break;
   case 36:
   case 35: /* -translit */outformat=TRANSLIT; break;
   case 40: /* -tokoi8u */outformat=KOI8U; DefaultLFStyle=LFS_LF; break;
   case 43: /* -tomacu */
   case 44: /* -tomac_u */outformat=MACU; DefaultLFStyle=LFS_LF; break;
   case 47: /* -toiso_ir_111 */
   case 48: /* -toisoir111 */outformat=ISOIR111; DefaultLFStyle=LFS_LF; break;
   case 52: /* -to857 */outformat=DOS857; DefaultLFStyle=LFS_CRLF; break;
   case 54: /* -to1254 */outformat=WIN1254; DefaultLFStyle=LFS_CRLF; break;
   case 56: /* -toiso8859_9 */outformat=ISO8859_9; DefaultLFStyle=LFS_LF; break;
   case 58: /* -tomacturk */outformat=MACTURK; DefaultLFStyle=LFS_LF; break;
   case 67: /* -to850 */outformat=DOS850; DefaultLFStyle=LFS_CRLF; break;
   case 68: /* -to1252 */outformat=WIN1252; DefaultLFStyle=LFS_CRLF; break;
   case 69: /* -toiso8859_1 */outformat=ISO8859_1; DefaultLFStyle=LFS_LF; break;
   case 70: /* -toiso8859_15 */outformat=ISO8859_15; DefaultLFStyle=LFS_LF; break;
   case 71: /* -tomacroman */outformat=MACROMAN; DefaultLFStyle=LFS_LF; break;
   default: if (NumFiles==0)
            {
             path1=argv[i]; NumFiles=1;
            }//if-else
            else
            {
             path2=argv[i]; NumFiles=2;
            }//end if-else
  }//end switch
 }//end for
 initlang();
 if (showHelp) help();
 if (! AllowBefore32)
 {
  big_tire=45; paragraph=36;
  abzac=183; center_point=249;
 }//end if
 if (SourceStyle) { quote=doublequote=96; }
 if (LfStyle==LFS_DEFAULT)
  LfStyle=DefaultLFStyle;
 if (showVInfo && (!showHelp)) puts(text[0]);
 if (outformat==TRANSLIT) AllowStrings=true;
 //begin transcoding
 if (NumFiles>1)
 {
  SameFiles=(strcmp(path1,path2)==0);
  if (SameFiles) tmpnam(destfile);
  else strcpy(destfile,path2);
  in1=fopen(path1,"rb");
  filesOk=(in1!=NULL);
  out2=fopen(destfile,"wb");
  filesOk=filesOk && (out2!=NULL);
  if (filesOk)
  {
     if (PreserveDateTime)
        getftime(fileno(in1), &fDateTime);
     puts(text[17]);
  }
  while (filesOk && loop)
  {
   ret=fscanf(in1,"%c",&ch1);
   if (loop=(ret!=EOF))
   {
   if (!OnlyAdjLF)
   {
     ch2=TransCode(ch1);
     if (ch2==0)
       ch2=ch1;
   }
   else
   {
     ch2=ch1; NowString=false;
   }
   if (ch2=='\r')
   {
     PrintCurChar = (LfStyle==LFS_NOALT);
   }
   else
   {
     PrintCurChar = true;
     if ((ch2=='\n') && (LfStyle==LFS_CRLF))
       { NowString=true; strcpy(outString, "\r\n"); }
   }
   if (NowString && AllowStrings)
     fprintf(out2,"%s",outString);
   else
     if (PrintCurChar)
       fprintf(out2,"%c",ch2);
   }
   filesOk=(!ferror(in1) && !ferror(out2));
  }//end while
  if (filesOk && PreserveDateTime)
     setftime(fileno(out2), &fDateTime);
  fclose(in1); fclose(out2);
 }//if-else
 else filesOk=false;
 if (SameFiles && filesOk)
 {
    remove(path2);
    rename(destfile, path2);
 }//end if
 if (filesOk)
     puts(text[18]);
 if (filesOk) return 0;
 else return 1;
}//end main
